function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/* eslint-disable react-hooks/exhaustive-deps */
import React, { useEffect } from 'react';
import { FocusScope as AriaFocusScope } from '@react-native-aria/focus';
import { FocusScopeContext } from './FocusScopeContext';
import Box from '../Box';

const FocusScope = ({
  children,
  contain,
  ...props
}) => {
  const {
    setFocusScopeRef,
    isFocusScopeContain,
    popFocusScopeRef
  } = React.useContext(FocusScopeContext);
  const focusScopeRef = React.useRef(null);
  useEffect(() => {
    if (focusScopeRef.current) {
      setFocusScopeRef(focusScopeRef.current);
    }
  }, [focusScopeRef, contain]);
  useEffect(() => {
    if (contain === false) {
      popFocusScopeRef();
    }
  }, [contain]);

  const isContain = () => {
    return isFocusScopeContain(focusScopeRef.current);
  };
  /* Todo: stoping mounted and unMounted everytime contain is change */


  if (contain === false) return /*#__PURE__*/React.createElement(React.Fragment, null);
  return /*#__PURE__*/React.createElement(AriaFocusScope, _extends({
    contain: contain && isContain()
  }, props), children, /*#__PURE__*/React.createElement(Box, {
    ref: focusScopeRef
  }));
};

export default FocusScope;
//# sourceMappingURL=FocusScope.js.map